[USACO09FEB]改造路Revamping Trails 题解

[USACO09FEB]改造路Revamping Trails 题解

题目地址:洛谷:【P2939】[USACO09FEB]改造路Revamping Trails – 洛谷、BZOJ:Problem 1579. — [Usaco2009 Feb]Revamping Trails 道路升级

题目描述

Farmer John dutifully checks on the cows every day. He traverses some of the M (1 <= M <= 50,000) trails conveniently numbered 1..M from pasture 1 all the way out to pasture N (a journey which is always possible for trail maps given in the test data). The N (1 <= N <= 10,000) pastures conveniently numbered 1..N on Farmer John’s farm are currently connected by bidirectional dirt trails. Each trail i connects pastures P1_i and P2_i (1 <= P1_i <= N; 1 <= P2_i <= N) and requires T_i (1 <= T_i <= 1,000,000) units of time to traverse.
He wants to revamp some of the trails on his farm to save time on his long journey. Specifically, he will choose K (1 <= K <= 20) trails to turn into highways, which will effectively reduce the trail’s traversal time to 0. Help FJ decide which trails to revamp to minimize the resulting time of getting from pasture 1 to N.
约翰一共有N个牧场.由M条布满尘埃的小径连接.小径可以双向通行.每天早上约翰从牧场1出发到牧场N去给奶牛检查身体.
通过每条小径都需要消耗一定的时间.约翰打算升级其中K条小径,使之成为高速公路.在高速公路上的通行几乎是瞬间完成的,所以高速公路的通行时间为0.
请帮助约翰决定对哪些小径进行升级,使他每天早上到牧场W花的时间最少.输出这个最少的时间.

输入输出格式

输入格式:
* Line 1: Three space-separated integers: N, M, and K
* Lines 2..M+1: Line i+1 describes trail i with three space-separated integers: P1_i, P2_i, and T_i

输出格式:
* Line 1: The length of the shortest path after revamping no more than K edges

输入输出样例

输入样例#1:

4 4 1 
1 2 10 
2 4 10 
1 3 1 
3 4 100 

输出样例#1:

1 

说明

K is 1; revamp trail 3->4 to take time 0 instead of 100. The new shortest path is 1->3->4, total traversal time now 1.

题解

考虑分层图最短路。令dis[i][j]为在第i个点且已经建了j条高速公路的最短路距离,最短路转移的时候向相邻点同层转移,加权为边权;向相邻点下一层转移,无加权,表示该边修了一条高速公路。修满k条比不修满k条肯定更优,因此答案为dis[n][k]。

代码

// Code by KSkun, 2018/5
#include <cstdio>
#include <cctype>
#include <cstring>

#include <vector>
#include <queue>

typedef long long LL;

inline char fgc() {
    static char buf[100000], *p1 = buf, *p2 = buf;
    return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2) ? EOF : *p1++;
}

inline LL readint() {
    register LL res = 0, neg = 1;
    register char c = fgc();
    while(!isdigit(c)) {
        if(c == '-') neg = -1;
        c = fgc();
    }
    while(isdigit(c)) {
        res = (res << 1) + (res << 3) + c - '0';
        c = fgc();
    }
    return res * neg;
}

const int MAXN = 10005;

struct Edge {
    int to, w;
};

std::vector<Edge> gra[MAXN];

int n, m, k;

int dis[MAXN][25];
bool vis[MAXN][25];

struct Node {
    int u, k, w;
    inline bool operator<(const Node &rhs) const {
        return w > rhs.w;
    }
};

std::priority_queue<Node> pq;

inline void dijkstra() {
    memset(dis, 0x3f, sizeof(dis));
    pq.push(Node {1, 0, 0});
    dis[1][0] = 0;
    while(!pq.empty()) {
        Node t = pq.top(); pq.pop();
        if(vis[t.u][t.k]) continue;
        vis[t.u][t.k] = true;
        for(auto e : gra[t.u]) {
            if(dis[e.to][t.k] > dis[t.u][t.k] + e.w) {
                dis[e.to][t.k] = dis[t.u][t.k] + e.w;
                pq.push(Node {e.to, t.k, dis[e.to][t.k]});
            }
            if(t.k < k && dis[e.to][t.k + 1] > dis[t.u][t.k]) {
                dis[e.to][t.k + 1] = dis[t.u][t.k];
                pq.push(Node {e.to, t.k + 1, dis[e.to][t.k + 1]});
            }
        }
    }
}

int u, v, w;

int main() {
    n = readint(); m = readint(); k = readint();
    for(int i = 1; i <= m; i++) {
        u = readint(); v = readint(); w = readint();
        gra[u].push_back(Edge {v, w});
        gra[v].push_back(Edge {u, w});
    }
    dijkstra();
    printf("%d", dis[n][k]);
    return 0;
}


发表回复

您的电子邮箱地址不会被公开。 必填项已用 * 标注

This site is protected by reCAPTCHA and the Google Privacy Policy and Terms of Service apply.

此站点使用Akismet来减少垃圾评论。了解我们如何处理您的评论数据